package com.ruoyi.yh.price.service.impl;

import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.yh.price.domain.Price;
import com.ruoyi.yh.price.domain.enums.PriceStatus;
import com.ruoyi.yh.price.service.PriceConverter;
import org.springframework.stereotype.Service;

/**
 * @author wjh
 * 2024/10/17
 */
@Service
public class PriceConverterImpl implements PriceConverter {

    /**
     * 创建时，转为PO
     */
    @Override
    public Price toPoByCreate(Price data) {
        if (data == null) {
            return null;
        }
        LoginUser loginUser = SecurityUtils.getLoginUser();

        Price po = new Price();
        po.setStatus(PriceStatus.WAIT_VERIFY.getStatus());
        po.setDisabled(false);
        po.setDeptId(data.getDeptId());
        po.setCategory(data.getCategory());
        po.setSize(data.getSize());
        po.setName(data.getName());
        po.setSubName(data.getSubName());
        po.setPattern(data.getPattern());
        po.setSpec(data.getSpec());
        po.setPrice(data.getPrice());
        po.setUnit(data.getUnit());
        po.setClassify(data.getClassify());
        po.setCreateId(loginUser.getUserId());
        po.setQuantityDenominator(data.getQuantityDenominator());
        po.setQuantityNumerator(data.getQuantityNumerator());
        po.setCreateBy(loginUser.getUsername());
        po.setRemark(data.getRemark());
        return po;
    }

    @Override
    public Price toPoByUpdate(Price data) {
        if (data == null) {
            return null;
        }
        LoginUser loginUser = SecurityUtils.getLoginUser();

        Price po = new Price();
        po.setStatus(PriceStatus.WAIT_VERIFY.getStatus());
        po.setPriceId(data.getPriceId());
        po.setDeptId(data.getDeptId());
        po.setCategory(data.getCategory());
        po.setSize(data.getSize());
        po.setName(data.getName());
        po.setSubName(data.getSubName());
        po.setPattern(data.getPattern());
        po.setSpec(data.getSpec());
        po.setPrice(data.getPrice());
        po.setUnit(data.getUnit());
        po.setClassify(data.getClassify());
        po.setQuantityDenominator(data.getQuantityDenominator());
        po.setQuantityNumerator(data.getQuantityNumerator());
        po.setUpdateId(loginUser.getUserId());
        po.setUpdateBy(loginUser.getUsername());
        po.setRemark(data.getRemark());
        return po;
    }
}
